#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
	Ajouts dynamiques de raccoucis dans l'application
	(en dehors de main.py)
	
'''
from PyQt5.QtWidgets import QAction, QShortcut
from PyQt5.QtGui import QIcon, QKeySequence

from customapp.customApp import *

class MenuShorts( ) :

	menuShorts=[]
	
	def __init__(self , parent, customApp ):
		self.parent = parent
		self.customApp = customApp

	# Point d'entrée depuis le menu principal		
	def appendShortcuts( self ) :		
		
		self.menuShorts = []
		
		shortcut_quickexport = QShortcut( QKeySequence('Ctrl+E'), self.parent)		
		shortcut_quickexport.activated.connect( lambda: self.customApp.onRapportexportQuick( ) )  
		
		shortcut_quickzip = QShortcut( QKeySequence('Ctrl+B'), self.parent)		
		shortcut_quickzip.activated.connect( lambda: self.customApp.onArchiveZip( ) )  

		shortcut_helpcontext = QShortcut( QKeySequence('F1'), self.parent)		
		shortcut_helpcontext.activated.connect( lambda: self.customApp.onContextHelpOpen( ) )  
		
		self.menuShorts.append(shortcut_quickexport)
		
		return self.menuShorts
	
