#!/usr/bin/env python3
# -*- coding: utf-8 -*-

"""
	Project class management
	
"""

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL

import lib.setting as AppSetting

from PyQt5.QtCore import QSettings

class Project:
		
	configProject = None
	projectFileName = None
	
	# Project dependant values :
	title=None
	description=None
	dbFile = None
	rootMedia = None
	pageAdd = None
	authorName = None
	authorMail = None
	decuJus = None
	# xxx
	rootExportPathEdit = None

	def __init__(self):
		
		self.configProject = None
		dbFile = None
		projectFileName = None
		rootMedia = None    
		pageAdd = None 
		authorName = None
		authorMail = None	
		decuJus = None	   
		# xxx
		rootExportPathEdit = None

	def load( self, projectFileName) :
		
		self.projectFileName = projectFileName				
		AppLog.log( LOG_INFO , "Load project: "+ self.projectFileName )		
		self.configProject = QSettings( self.projectFileName, QSettings.IniFormat)	
		self.dbFile = self.get('project/dbfile', '')
		self.rootMedia = self.get( 'project/rootmedia', '')		
		self.pageAdd = self.get( 'project/pageadd', '')		
		self.title = self.get( 'project/title', '')		
		self.description = self.get( 'project/summary', '')		
		self.authorName = self.get( 'project/authorname', '')		
		self.authorMail = self.get( 'project/authormail', '')	
		
		self.decuJus = self.get( 'project/decujus', '')	
		
		# xxx
		self.rootExportPath = self.get( 'project/rootexportpath', '')	
		
	
		AppLog.log( LOG_INFO , "Load project: title="+ self.title )
		AppLog.log( LOG_INFO , "Load project: dbFile="+ self.dbFile )
		AppLog.log( LOG_INFO , "Load project: rootMedia="+ self.rootMedia )
		
		return self

	def save( self, projectFileName) :
		
		self.projectFileName = projectFileName
		self.configProject = QSettings(projectFileName, QSettings.IniFormat)	
		
		self.set('project/dbfile', self.dbFile)
		self.set('project/rootmedia', self.rootMedia)        
		self.set('project/pageadd', self.pageAdd)        
		self.set('project/title', self.title)   
		self.set('project/summary', self.description)   	
		self.set('project/authorname', self.authorName)   	
		self.set('project/authormail', self.authorMail)   
		self.set('project/decujus', self.decuJus)   
		
		# xxx
		self.set('project/rootexportpath', self.rootExportPath)   
		
	
	def get( self, keysection, defaultvalue ) :
				
		if self.configProject.value(keysection) is not None:			
			return self.configProject.value(keysection)
			
		return defaultvalue

	def getInt( self, keysection, defaultvalue ) :
				
		if self.configProject.value(keysection) is not None:			
			return int(self.configProject.value(keysection))
			
		return defaultvalue
		
	def set( self, keysection, value ) :		
		
		self.configProject.setValue(keysection, value)  
		self.configProject.sync()

