#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : depot.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Depot :

	log = None
	lastError = None

	id = None
	name = None
	code = None
	description = None
	icon = None
	url = None
	adress_1 = None
	adress_2 = None
	city = None
	zip = None
	country = None



	def __init__(self, id=None, name= None, code= None, description= None, icon= None, url= None, adress_1= None, adress_2= None, city= None, zip= None, country= None   ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setCode( code )
			self.setDescription( description )
			self.setIcon( icon )
			self.setUrl( url )
			self.setAdress_1( adress_1 )
			self.setAdress_2( adress_2 )
			self.setCity( city )
			self.setZip( zip )
			self.setCountry( country )




		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setCode( self, code ) :
		self.code = code
	def getCode( self ) :
		return self.code

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon

	def setUrl( self, url ) :
		self.url = url
	def getUrl( self ) :
		return self.url

	def setAdress_1( self, adress_1 ) :
		self.adress_1 = adress_1
	def getAdress_1( self ) :
		return self.adress_1

	def setAdress_2( self, adress_2 ) :
		self.adress_2 = adress_2
	def getAdress_2( self ) :
		return self.adress_2

	def setCity( self, city ) :
		self.city = city
	def getCity( self ) :
		return self.city

	def setZip( self, zip ) :
		self.zip = zip
	def getZip( self ) :
		return self.zip

	def setCountry( self, country ) :
		self.country = country
	def getCountry( self ) :
		return self.country


	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class DepotsDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.description as 'description', a.icon as 'icon', a.url as 'url', a.adress_1 as 'adress_1', a.adress_2 as 'adress_2', a.city as 'city', a.zip as 'zip', a.country as 'country' \
					\
				from depot a \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					depotObj = Depot( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['description'], dbvalue['icon'], dbvalue['url'], dbvalue['adress_1'], dbvalue['adress_2'], dbvalue['city'], dbvalue['zip'], dbvalue['country'] 
										 )
					resultlist.append( depotObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.description as 'description', a.icon as 'icon', a.url as 'url', a.adress_1 as 'adress_1', a.adress_2 as 'adress_2', a.city as 'city', a.zip as 'zip', a.country as 'country' \
					\
				from depot a \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					depotObj = Depot( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['description'], dbvalue['icon'], dbvalue['url'], dbvalue['adress_1'], dbvalue['adress_2'], dbvalue['city'], dbvalue['zip'], dbvalue['country'] 
										 )
					resultlist.append( depotObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.description as 'description', a.icon as 'icon', a.url as 'url', a.adress_1 as 'adress_1', a.adress_2 as 'adress_2', a.city as 'city', a.zip as 'zip', a.country as 'country' \
					\
				from depot a \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					depotObj = Depot( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['description'], dbvalue['icon'], dbvalue['url'], dbvalue['adress_1'], dbvalue['adress_2'], dbvalue['city'], dbvalue['zip'], dbvalue['country'] 
										 )
					resultlist.append( depotObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.description as 'description', a.icon as 'icon', a.url as 'url', a.adress_1 as 'adress_1', a.adress_2 as 'adress_2', a.city as 'city', a.zip as 'zip', a.country as 'country' \
					\
				from depot a \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					depotObj = Depot( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['description'], dbvalue['icon'], dbvalue['url'], dbvalue['adress_1'], dbvalue['adress_2'], dbvalue['city'], dbvalue['zip'], dbvalue['country'] 
										 )
					resultlist.append( depotObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, depotObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE depot set name = ?, code = ?, description = ?, icon = ?, url = ?, adress_1 = ?, adress_2 = ?, city = ?, zip = ?, country = ?  WHERE id = ?"

		try:
			if depotObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ depotObj.getSql(depotObj.name),  depotObj.getSql(depotObj.code),  depotObj.getSql(depotObj.description),  depotObj.getSql(depotObj.icon),  depotObj.getSql(depotObj.url),  depotObj.getSql(depotObj.adress_1),  depotObj.getSql(depotObj.adress_2),  depotObj.getSql(depotObj.city),  depotObj.getSql(depotObj.zip),  depotObj.getSql(depotObj.country) , depotObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = depotObj.id
					return True
				else :
					result = self.insert ( depotObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( depotObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( depotObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( depotObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( depotObj , self.lastError, sqlSt )

		return False

	def insert ( self, depotObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO depot ( name,  code,  description,  icon,  url,  adress_1,  adress_2,  city,  zip,  country ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  depotObj.getSql(depotObj.name),  depotObj.getSql(depotObj.code),  depotObj.getSql(depotObj.description),  depotObj.getSql(depotObj.icon),  depotObj.getSql(depotObj.url),  depotObj.getSql(depotObj.adress_1),  depotObj.getSql(depotObj.adress_2),  depotObj.getSql(depotObj.city),  depotObj.getSql(depotObj.zip),  depotObj.getSql(depotObj.country)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( depotObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( depotObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM depot WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from depot' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  code = " + str( eventObj.code ))
		print("  description = " + str( eventObj.description ))
		print("  icon = " + str( eventObj.icon ))
		print("  url = " + str( eventObj.url ))
		print("  adress_1 = " + str( eventObj.adress_1 ))
		print("  adress_2 = " + str( eventObj.adress_2 ))
		print("  city = " + str( eventObj.city ))
		print("  zip = " + str( eventObj.zip ))
		print("  country = " + str( eventObj.country ))



	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

