#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : document.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Document :

	log = None
	lastError = None

	id = None
	name = None
	description = None
	private = None
	icon = None
	url = None
	cote = None
	notesearch = None
	sortorder = None
	depot_id = None
	documenttype_id = None
	datecreated = None

	b1_name = None
	c2_name = None


	def __init__(self, id=None, name= None, description= None, private= None, icon= None, url= None, cote= None, notesearch= None, sortorder= None, depot_id= None, documenttype_id= None, datecreated= None,   b1_name= None, c2_name= None ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setDescription( description )
			self.setPrivate( private )
			self.setIcon( icon )
			self.setUrl( url )
			self.setCote( cote )
			self.setNotesearch( notesearch )
			self.setSortorder( sortorder )
			self.setDepot_id( depot_id )
			self.setDocumenttype_id( documenttype_id )
			self.setDatecreated( datecreated )

			self.setB1_name( b1_name )
			self.setC2_name( c2_name )



		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setPrivate( self, private ) :
		self.private = private
	def getPrivate( self ) :
		return self.private

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon

	def setUrl( self, url ) :
		self.url = url
	def getUrl( self ) :
		return self.url

	def setCote( self, cote ) :
		self.cote = cote
	def getCote( self ) :
		return self.cote

	def setNotesearch( self, notesearch ) :
		self.notesearch = notesearch
	def getNotesearch( self ) :
		return self.notesearch

	def setSortorder( self, sortorder ) :
		self.sortorder = sortorder
	def getSortorder( self ) :
		return self.sortorder

	def setDepot_id( self, depot_id ) :
		self.depot_id = depot_id
	def getDepot_id( self ) :
		return self.depot_id

	def setDocumenttype_id( self, documenttype_id ) :
		self.documenttype_id = documenttype_id
	def getDocumenttype_id( self ) :
		return self.documenttype_id

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	def setB1_name( self, b1_name ) :
		self.b1_name = b1_name
	def getB1_name( self ) :
		return self.b1_name

	def setC2_name( self, c2_name ) :
		self.c2_name = c2_name
	def getC2_name( self ) :
		return self.c2_name

	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class DocumentsDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.url as 'url', a.cote as 'cote', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.depot_id as 'depot_id', a.documenttype_id as 'documenttype_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from document a \
 				left outer join documenttype c2 on c2.id =  a.documenttype_id \
 				left outer join depot b1 on b1.id =  a.depot_id \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					documentObj = Document( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['url'], dbvalue['cote'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['depot_id'], dbvalue['documenttype_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( documentObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.url as 'url', a.cote as 'cote', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.depot_id as 'depot_id', a.documenttype_id as 'documenttype_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from document a \
 				left outer join documenttype c2 on c2.id =  a.documenttype_id \
 				left outer join depot b1 on b1.id =  a.depot_id \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					documentObj = Document( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['url'], dbvalue['cote'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['depot_id'], dbvalue['documenttype_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( documentObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.url as 'url', a.cote as 'cote', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.depot_id as 'depot_id', a.documenttype_id as 'documenttype_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from document a \
 				left outer join documenttype c2 on c2.id =  a.documenttype_id \
 				left outer join depot b1 on b1.id =  a.depot_id \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					documentObj = Document( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['url'], dbvalue['cote'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['depot_id'], dbvalue['documenttype_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( documentObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.url as 'url', a.cote as 'cote', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.depot_id as 'depot_id', a.documenttype_id as 'documenttype_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from document a \
 				left outer join documenttype c2 on c2.id =  a.documenttype_id \
 				left outer join depot b1 on b1.id =  a.depot_id \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					documentObj = Document( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['url'], dbvalue['cote'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['depot_id'], dbvalue['documenttype_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( documentObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, documentObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE document set name = ?, description = ?, private = ?, icon = ?, url = ?, cote = ?, notesearch = ?, sortorder = ?, depot_id = ?, documenttype_id = ?, datecreated = ?  WHERE id = ?"

		try:
			if documentObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ documentObj.getSql(documentObj.name),  documentObj.getSql(documentObj.description),  documentObj.getSql(documentObj.private),  documentObj.getSql(documentObj.icon),  documentObj.getSql(documentObj.url),  documentObj.getSql(documentObj.cote),  documentObj.getSql(documentObj.notesearch),  documentObj.getSql(documentObj.sortorder),  documentObj.getSql(documentObj.depot_id),  documentObj.getSql(documentObj.documenttype_id),  documentObj.getSql(documentObj.datecreated) , documentObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = documentObj.id
					return True
				else :
					result = self.insert ( documentObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( documentObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( documentObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( documentObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( documentObj , self.lastError, sqlSt )

		return False

	def insert ( self, documentObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO document ( name,  description,  private,  icon,  url,  cote,  notesearch,  sortorder,  depot_id,  documenttype_id,  datecreated ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  documentObj.getSql(documentObj.name),  documentObj.getSql(documentObj.description),  documentObj.getSql(documentObj.private),  documentObj.getSql(documentObj.icon),  documentObj.getSql(documentObj.url),  documentObj.getSql(documentObj.cote),  documentObj.getSql(documentObj.notesearch),  documentObj.getSql(documentObj.sortorder),  documentObj.getSql(documentObj.depot_id),  documentObj.getSql(documentObj.documenttype_id),  documentObj.getSql(documentObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( documentObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( documentObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM document WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from document' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  description = " + str( eventObj.description ))
		print("  private = " + str( eventObj.private ))
		print("  icon = " + str( eventObj.icon ))
		print("  url = " + str( eventObj.url ))
		print("  cote = " + str( eventObj.cote ))
		print("  notesearch = " + str( eventObj.notesearch ))
		print("  sortorder = " + str( eventObj.sortorder ))
		print("  depot_id = " + str( eventObj.depot_id ))
		print("  documenttype_id = " + str( eventObj.documenttype_id ))
		print("  datecreated = " + str( eventObj.datecreated ))

		print("  b1_name = " + str( eventObj.b1_name ))
		print("  c2_name = " + str( eventObj.c2_name ))


	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

