#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : event.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Event :

	log = None
	lastError = None

	id = None
	name = None
	description = None
	private = None
	icon = None
	date_begin = None
	date_begin_format = None
	date_begin_accurate = None
	notesearch = None
	person_1_id = None
	person_2_id = None
	person_3_id = None
	eventtype_id = None
	place_id = None
	datecreated = None
	sortorder = None

	b1_name = None
	c2_name = None
	d3_name = None
	e4_name = None
	f5_name = None


	def __init__(self, id=None, name= None, description= None, private= None, icon= None, date_begin= None, date_begin_format= None, date_begin_accurate= None, notesearch= None, person_1_id= None, person_2_id= None, person_3_id= None, eventtype_id= None, place_id= None, datecreated= None, sortorder= None,   b1_name= None, c2_name= None, d3_name= None, e4_name= None, f5_name= None ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setDescription( description )
			self.setPrivate( private )
			self.setIcon( icon )
			self.setDate_begin( date_begin )
			self.setDate_begin_format( date_begin_format )
			self.setDate_begin_accurate( date_begin_accurate )
			self.setNotesearch( notesearch )
			self.setPerson_1_id( person_1_id )
			self.setPerson_2_id( person_2_id )
			self.setPerson_3_id( person_3_id )
			self.setEventtype_id( eventtype_id )
			self.setPlace_id( place_id )
			self.setDatecreated( datecreated )
			self.setSortorder( sortorder )

			self.setB1_name( b1_name )
			self.setC2_name( c2_name )
			self.setD3_name( d3_name )
			self.setE4_name( e4_name )
			self.setF5_name( f5_name )



		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setPrivate( self, private ) :
		self.private = private
	def getPrivate( self ) :
		return self.private

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon

	def setDate_begin( self, date_begin ) :
		self.date_begin = date_begin
	def getDate_begin( self ) :
		return self.date_begin

	def setDate_begin_format( self, date_begin_format ) :
		self.date_begin_format = date_begin_format
	def getDate_begin_format( self ) :
		return self.date_begin_format

	def setDate_begin_accurate( self, date_begin_accurate ) :
		self.date_begin_accurate = date_begin_accurate
	def getDate_begin_accurate( self ) :
		return self.date_begin_accurate

	def setNotesearch( self, notesearch ) :
		self.notesearch = notesearch
	def getNotesearch( self ) :
		return self.notesearch

	def setPerson_1_id( self, person_1_id ) :
		self.person_1_id = person_1_id
	def getPerson_1_id( self ) :
		return self.person_1_id

	def setPerson_2_id( self, person_2_id ) :
		self.person_2_id = person_2_id
	def getPerson_2_id( self ) :
		return self.person_2_id

	def setPerson_3_id( self, person_3_id ) :
		self.person_3_id = person_3_id
	def getPerson_3_id( self ) :
		return self.person_3_id

	def setEventtype_id( self, eventtype_id ) :
		self.eventtype_id = eventtype_id
	def getEventtype_id( self ) :
		return self.eventtype_id

	def setPlace_id( self, place_id ) :
		self.place_id = place_id
	def getPlace_id( self ) :
		return self.place_id

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated

	def setSortorder( self, sortorder ) :
		self.sortorder = sortorder
	def getSortorder( self ) :
		return self.sortorder


	def setB1_name( self, b1_name ) :
		self.b1_name = b1_name
	def getB1_name( self ) :
		return self.b1_name

	def setC2_name( self, c2_name ) :
		self.c2_name = c2_name
	def getC2_name( self ) :
		return self.c2_name

	def setD3_name( self, d3_name ) :
		self.d3_name = d3_name
	def getD3_name( self ) :
		return self.d3_name

	def setE4_name( self, e4_name ) :
		self.e4_name = e4_name
	def getE4_name( self ) :
		return self.e4_name

	def setF5_name( self, f5_name ) :
		self.f5_name = f5_name
	def getF5_name( self ) :
		return self.f5_name

	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class EventsDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.date_begin as 'date_begin', a.date_begin_format as 'date_begin_format', a.date_begin_accurate as 'date_begin_accurate', a.notesearch as 'notesearch', a.person_1_id as 'person_1_id', a.person_2_id as 'person_2_id', a.person_3_id as 'person_3_id', a.eventtype_id as 'eventtype_id', a.place_id as 'place_id', a.datecreated as 'datecreated', a.sortorder as 'sortorder', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name', f5.name as 'f5.name'	\
				from event a \
 				left outer join place f5 on f5.id =  a.place_id \
 				left outer join eventtype e4 on e4.id =  a.eventtype_id \
 				left outer join person d3 on d3.id =  a.person_3_id \
 				left outer join person c2 on c2.id =  a.person_2_id \
 				left outer join person b1 on b1.id =  a.person_1_id \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventObj = Event( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['date_begin'], dbvalue['date_begin_format'], dbvalue['date_begin_accurate'], dbvalue['notesearch'], dbvalue['person_1_id'], dbvalue['person_2_id'], dbvalue['person_3_id'], dbvalue['eventtype_id'], dbvalue['place_id'], dbvalue['datecreated'], dbvalue['sortorder'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'], dbvalue['f5.name'] )
					resultlist.append( eventObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.date_begin as 'date_begin', a.date_begin_format as 'date_begin_format', a.date_begin_accurate as 'date_begin_accurate', a.notesearch as 'notesearch', a.person_1_id as 'person_1_id', a.person_2_id as 'person_2_id', a.person_3_id as 'person_3_id', a.eventtype_id as 'eventtype_id', a.place_id as 'place_id', a.datecreated as 'datecreated', a.sortorder as 'sortorder', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name', f5.name as 'f5.name'	\
				from event a \
 				left outer join place f5 on f5.id =  a.place_id \
 				left outer join eventtype e4 on e4.id =  a.eventtype_id \
 				left outer join person d3 on d3.id =  a.person_3_id \
 				left outer join person c2 on c2.id =  a.person_2_id \
 				left outer join person b1 on b1.id =  a.person_1_id \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventObj = Event( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['date_begin'], dbvalue['date_begin_format'], dbvalue['date_begin_accurate'], dbvalue['notesearch'], dbvalue['person_1_id'], dbvalue['person_2_id'], dbvalue['person_3_id'], dbvalue['eventtype_id'], dbvalue['place_id'], dbvalue['datecreated'], dbvalue['sortorder'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'], dbvalue['f5.name'] )
					resultlist.append( eventObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.date_begin as 'date_begin', a.date_begin_format as 'date_begin_format', a.date_begin_accurate as 'date_begin_accurate', a.notesearch as 'notesearch', a.person_1_id as 'person_1_id', a.person_2_id as 'person_2_id', a.person_3_id as 'person_3_id', a.eventtype_id as 'eventtype_id', a.place_id as 'place_id', a.datecreated as 'datecreated', a.sortorder as 'sortorder', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name', f5.name as 'f5.name'	\
				from event a \
 				left outer join place f5 on f5.id =  a.place_id \
 				left outer join eventtype e4 on e4.id =  a.eventtype_id \
 				left outer join person d3 on d3.id =  a.person_3_id \
 				left outer join person c2 on c2.id =  a.person_2_id \
 				left outer join person b1 on b1.id =  a.person_1_id \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventObj = Event( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['date_begin'], dbvalue['date_begin_format'], dbvalue['date_begin_accurate'], dbvalue['notesearch'], dbvalue['person_1_id'], dbvalue['person_2_id'], dbvalue['person_3_id'], dbvalue['eventtype_id'], dbvalue['place_id'], dbvalue['datecreated'], dbvalue['sortorder'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'], dbvalue['f5.name'] )
					resultlist.append( eventObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.date_begin as 'date_begin', a.date_begin_format as 'date_begin_format', a.date_begin_accurate as 'date_begin_accurate', a.notesearch as 'notesearch', a.person_1_id as 'person_1_id', a.person_2_id as 'person_2_id', a.person_3_id as 'person_3_id', a.eventtype_id as 'eventtype_id', a.place_id as 'place_id', a.datecreated as 'datecreated', a.sortorder as 'sortorder', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name', f5.name as 'f5.name'	\
				from event a \
 				left outer join place f5 on f5.id =  a.place_id \
 				left outer join eventtype e4 on e4.id =  a.eventtype_id \
 				left outer join person d3 on d3.id =  a.person_3_id \
 				left outer join person c2 on c2.id =  a.person_2_id \
 				left outer join person b1 on b1.id =  a.person_1_id \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventObj = Event( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['date_begin'], dbvalue['date_begin_format'], dbvalue['date_begin_accurate'], dbvalue['notesearch'], dbvalue['person_1_id'], dbvalue['person_2_id'], dbvalue['person_3_id'], dbvalue['eventtype_id'], dbvalue['place_id'], dbvalue['datecreated'], dbvalue['sortorder'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'], dbvalue['f5.name'] )
					resultlist.append( eventObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, eventObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE event set name = ?, description = ?, private = ?, icon = ?, date_begin = ?, date_begin_format = ?, date_begin_accurate = ?, notesearch = ?, person_1_id = ?, person_2_id = ?, person_3_id = ?, eventtype_id = ?, place_id = ?, datecreated = ?, sortorder = ?  WHERE id = ?"

		try:
			if eventObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ eventObj.getSql(eventObj.name),  eventObj.getSql(eventObj.description),  eventObj.getSql(eventObj.private),  eventObj.getSql(eventObj.icon),  eventObj.getSql(eventObj.date_begin),  eventObj.getSql(eventObj.date_begin_format),  eventObj.getSql(eventObj.date_begin_accurate),  eventObj.getSql(eventObj.notesearch),  eventObj.getSql(eventObj.person_1_id),  eventObj.getSql(eventObj.person_2_id),  eventObj.getSql(eventObj.person_3_id),  eventObj.getSql(eventObj.eventtype_id),  eventObj.getSql(eventObj.place_id),  eventObj.getSql(eventObj.datecreated),  eventObj.getSql(eventObj.sortorder) , eventObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = eventObj.id
					return True
				else :
					result = self.insert ( eventObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( eventObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( eventObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( eventObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( eventObj , self.lastError, sqlSt )

		return False

	def insert ( self, eventObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO event ( name,  description,  private,  icon,  date_begin,  date_begin_format,  date_begin_accurate,  notesearch,  person_1_id,  person_2_id,  person_3_id,  eventtype_id,  place_id,  datecreated,  sortorder ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  eventObj.getSql(eventObj.name),  eventObj.getSql(eventObj.description),  eventObj.getSql(eventObj.private),  eventObj.getSql(eventObj.icon),  eventObj.getSql(eventObj.date_begin),  eventObj.getSql(eventObj.date_begin_format),  eventObj.getSql(eventObj.date_begin_accurate),  eventObj.getSql(eventObj.notesearch),  eventObj.getSql(eventObj.person_1_id),  eventObj.getSql(eventObj.person_2_id),  eventObj.getSql(eventObj.person_3_id),  eventObj.getSql(eventObj.eventtype_id),  eventObj.getSql(eventObj.place_id),  eventObj.getSql(eventObj.datecreated),  eventObj.getSql(eventObj.sortorder)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( eventObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( eventObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM event WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from event' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  description = " + str( eventObj.description ))
		print("  private = " + str( eventObj.private ))
		print("  icon = " + str( eventObj.icon ))
		print("  date_begin = " + str( eventObj.date_begin ))
		print("  date_begin_format = " + str( eventObj.date_begin_format ))
		print("  date_begin_accurate = " + str( eventObj.date_begin_accurate ))
		print("  notesearch = " + str( eventObj.notesearch ))
		print("  person_1_id = " + str( eventObj.person_1_id ))
		print("  person_2_id = " + str( eventObj.person_2_id ))
		print("  person_3_id = " + str( eventObj.person_3_id ))
		print("  eventtype_id = " + str( eventObj.eventtype_id ))
		print("  place_id = " + str( eventObj.place_id ))
		print("  datecreated = " + str( eventObj.datecreated ))
		print("  sortorder = " + str( eventObj.sortorder ))

		print("  b1_name = " + str( eventObj.b1_name ))
		print("  c2_name = " + str( eventObj.c2_name ))
		print("  d3_name = " + str( eventObj.d3_name ))
		print("  e4_name = " + str( eventObj.e4_name ))
		print("  f5_name = " + str( eventObj.f5_name ))


	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

