#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : event_source.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Event_source :

	log = None
	lastError = None

	id = None
	event_id = None
	source_id = None
	document_id = None
	datecreated = None

	b1_name = None
	c2_name = None
	d3_name = None


	def __init__(self, id=None, event_id= None, source_id= None, document_id= None, datecreated= None,   b1_name= None, c2_name= None, d3_name= None ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setEvent_id( event_id )
			self.setSource_id( source_id )
			self.setDocument_id( document_id )
			self.setDatecreated( datecreated )

			self.setB1_name( b1_name )
			self.setC2_name( c2_name )
			self.setD3_name( d3_name )



		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setEvent_id( self, event_id ) :
		self.event_id = event_id
	def getEvent_id( self ) :
		return self.event_id

	def setSource_id( self, source_id ) :
		self.source_id = source_id
	def getSource_id( self ) :
		return self.source_id

	def setDocument_id( self, document_id ) :
		self.document_id = document_id
	def getDocument_id( self ) :
		return self.document_id

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	def setB1_name( self, b1_name ) :
		self.b1_name = b1_name
	def getB1_name( self ) :
		return self.b1_name

	def setC2_name( self, c2_name ) :
		self.c2_name = c2_name
	def getC2_name( self ) :
		return self.c2_name

	def setD3_name( self, d3_name ) :
		self.d3_name = d3_name
	def getD3_name( self ) :
		return self.d3_name

	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class Event_sourcesDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.event_id as 'event_id', a.source_id as 'source_id', a.document_id as 'document_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name'	\
				from event_source a \
 				left outer join document d3 on d3.id =  a.document_id \
 				left outer join source c2 on c2.id =  a.source_id \
 				left outer join event b1 on b1.id =  a.event_id \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					event_sourceObj = Event_source( dbvalue['id'], dbvalue['event_id'], dbvalue['source_id'], dbvalue['document_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'] )
					resultlist.append( event_sourceObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.event_id as 'event_id', a.source_id as 'source_id', a.document_id as 'document_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name'	\
				from event_source a \
 				left outer join document d3 on d3.id =  a.document_id \
 				left outer join source c2 on c2.id =  a.source_id \
 				left outer join event b1 on b1.id =  a.event_id \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					event_sourceObj = Event_source( dbvalue['id'], dbvalue['event_id'], dbvalue['source_id'], dbvalue['document_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'] )
					resultlist.append( event_sourceObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.event_id as 'event_id', a.source_id as 'source_id', a.document_id as 'document_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name'	\
				from event_source a \
 				left outer join document d3 on d3.id =  a.document_id \
 				left outer join source c2 on c2.id =  a.source_id \
 				left outer join event b1 on b1.id =  a.event_id \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					event_sourceObj = Event_source( dbvalue['id'], dbvalue['event_id'], dbvalue['source_id'], dbvalue['document_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'] )
					resultlist.append( event_sourceObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.event_id as 'event_id', a.source_id as 'source_id', a.document_id as 'document_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name'	\
				from event_source a \
 				left outer join document d3 on d3.id =  a.document_id \
 				left outer join source c2 on c2.id =  a.source_id \
 				left outer join event b1 on b1.id =  a.event_id \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					event_sourceObj = Event_source( dbvalue['id'], dbvalue['event_id'], dbvalue['source_id'], dbvalue['document_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'] )
					resultlist.append( event_sourceObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, event_sourceObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE event_source set event_id = ?, source_id = ?, document_id = ?, datecreated = ?  WHERE id = ?"

		try:
			if event_sourceObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ event_sourceObj.getSql(event_sourceObj.event_id),  event_sourceObj.getSql(event_sourceObj.source_id),  event_sourceObj.getSql(event_sourceObj.document_id),  event_sourceObj.getSql(event_sourceObj.datecreated) , event_sourceObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = event_sourceObj.id
					return True
				else :
					result = self.insert ( event_sourceObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( event_sourceObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( event_sourceObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( event_sourceObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( event_sourceObj , self.lastError, sqlSt )

		return False

	def insert ( self, event_sourceObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO event_source ( event_id,  source_id,  document_id,  datecreated ) VALUES (?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  event_sourceObj.getSql(event_sourceObj.event_id),  event_sourceObj.getSql(event_sourceObj.source_id),  event_sourceObj.getSql(event_sourceObj.document_id),  event_sourceObj.getSql(event_sourceObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( event_sourceObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( event_sourceObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM event_source WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from event_source' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  event_id = " + str( eventObj.event_id ))
		print("  source_id = " + str( eventObj.source_id ))
		print("  document_id = " + str( eventObj.document_id ))
		print("  datecreated = " + str( eventObj.datecreated ))

		print("  b1_name = " + str( eventObj.b1_name ))
		print("  c2_name = " + str( eventObj.c2_name ))
		print("  d3_name = " + str( eventObj.d3_name ))


	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

