#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : eventtype.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Eventtype :

	log = None
	lastError = None

	id = None
	name = None
	code = None
	category = None
	description = None
	icon = None



	def __init__(self, id=None, name= None, code= None, category= None, description= None, icon= None   ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setCode( code )
			self.setCategory( category )
			self.setDescription( description )
			self.setIcon( icon )




		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setCode( self, code ) :
		self.code = code
	def getCode( self ) :
		return self.code

	def setCategory( self, category ) :
		self.category = category
	def getCategory( self ) :
		return self.category

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon


	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class EventtypesDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.category as 'category', a.description as 'description', a.icon as 'icon' \
					\
				from eventtype a \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventtypeObj = Eventtype( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['category'], dbvalue['description'], dbvalue['icon'] 
										 )
					resultlist.append( eventtypeObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.category as 'category', a.description as 'description', a.icon as 'icon' \
					\
				from eventtype a \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventtypeObj = Eventtype( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['category'], dbvalue['description'], dbvalue['icon'] 
										 )
					resultlist.append( eventtypeObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.category as 'category', a.description as 'description', a.icon as 'icon' \
					\
				from eventtype a \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventtypeObj = Eventtype( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['category'], dbvalue['description'], dbvalue['icon'] 
										 )
					resultlist.append( eventtypeObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.code as 'code', a.category as 'category', a.description as 'description', a.icon as 'icon' \
					\
				from eventtype a \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					eventtypeObj = Eventtype( dbvalue['id'], dbvalue['name'], dbvalue['code'], dbvalue['category'], dbvalue['description'], dbvalue['icon'] 
										 )
					resultlist.append( eventtypeObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, eventtypeObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE eventtype set name = ?, code = ?, category = ?, description = ?, icon = ?  WHERE id = ?"

		try:
			if eventtypeObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ eventtypeObj.getSql(eventtypeObj.name),  eventtypeObj.getSql(eventtypeObj.code),  eventtypeObj.getSql(eventtypeObj.category),  eventtypeObj.getSql(eventtypeObj.description),  eventtypeObj.getSql(eventtypeObj.icon) , eventtypeObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = eventtypeObj.id
					return True
				else :
					result = self.insert ( eventtypeObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( eventtypeObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( eventtypeObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( eventtypeObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( eventtypeObj , self.lastError, sqlSt )

		return False

	def insert ( self, eventtypeObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO eventtype ( name,  code,  category,  description,  icon ) VALUES (?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  eventtypeObj.getSql(eventtypeObj.name),  eventtypeObj.getSql(eventtypeObj.code),  eventtypeObj.getSql(eventtypeObj.category),  eventtypeObj.getSql(eventtypeObj.description),  eventtypeObj.getSql(eventtypeObj.icon)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( eventtypeObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( eventtypeObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM eventtype WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from eventtype' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  code = " + str( eventObj.code ))
		print("  category = " + str( eventObj.category ))
		print("  description = " + str( eventObj.description ))
		print("  icon = " + str( eventObj.icon ))



	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

