#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : media.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Media :

	log = None
	lastError = None

	id = None
	name = None
	url = None
	datemedia = None
	datemedia_format = None
	datemedia_accurate = None
	description = None
	dimension = None
	origin = None
	private = None
	notesearch = None
	sortorder = None
	keyword = None
	documenttype_id = None
	depot_id = None
	event_id = None
	place_id = None
	datecreated = None

	b1_name = None
	c2_name = None
	d3_name = None
	e4_name = None


	def __init__(self, id=None, name= None, url= None, datemedia= None, datemedia_format= None, datemedia_accurate= None, description= None, dimension= None, origin= None, private= None, notesearch= None, sortorder= None, keyword= None, documenttype_id= None, depot_id= None, event_id= None, place_id= None, datecreated= None,   b1_name= None, c2_name= None, d3_name= None, e4_name= None ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setUrl( url )
			self.setDatemedia( datemedia )
			self.setDatemedia_format( datemedia_format )
			self.setDatemedia_accurate( datemedia_accurate )
			self.setDescription( description )
			self.setDimension( dimension )
			self.setOrigin( origin )
			self.setPrivate( private )
			self.setNotesearch( notesearch )
			self.setSortorder( sortorder )
			self.setKeyword( keyword )
			self.setDocumenttype_id( documenttype_id )
			self.setDepot_id( depot_id )
			self.setEvent_id( event_id )
			self.setPlace_id( place_id )
			self.setDatecreated( datecreated )

			self.setB1_name( b1_name )
			self.setC2_name( c2_name )
			self.setD3_name( d3_name )
			self.setE4_name( e4_name )



		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setUrl( self, url ) :
		self.url = url
	def getUrl( self ) :
		return self.url

	def setDatemedia( self, datemedia ) :
		self.datemedia = datemedia
	def getDatemedia( self ) :
		return self.datemedia

	def setDatemedia_format( self, datemedia_format ) :
		self.datemedia_format = datemedia_format
	def getDatemedia_format( self ) :
		return self.datemedia_format

	def setDatemedia_accurate( self, datemedia_accurate ) :
		self.datemedia_accurate = datemedia_accurate
	def getDatemedia_accurate( self ) :
		return self.datemedia_accurate

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setDimension( self, dimension ) :
		self.dimension = dimension
	def getDimension( self ) :
		return self.dimension

	def setOrigin( self, origin ) :
		self.origin = origin
	def getOrigin( self ) :
		return self.origin

	def setPrivate( self, private ) :
		self.private = private
	def getPrivate( self ) :
		return self.private

	def setNotesearch( self, notesearch ) :
		self.notesearch = notesearch
	def getNotesearch( self ) :
		return self.notesearch

	def setSortorder( self, sortorder ) :
		self.sortorder = sortorder
	def getSortorder( self ) :
		return self.sortorder

	def setKeyword( self, keyword ) :
		self.keyword = keyword
	def getKeyword( self ) :
		return self.keyword

	def setDocumenttype_id( self, documenttype_id ) :
		self.documenttype_id = documenttype_id
	def getDocumenttype_id( self ) :
		return self.documenttype_id

	def setDepot_id( self, depot_id ) :
		self.depot_id = depot_id
	def getDepot_id( self ) :
		return self.depot_id

	def setEvent_id( self, event_id ) :
		self.event_id = event_id
	def getEvent_id( self ) :
		return self.event_id

	def setPlace_id( self, place_id ) :
		self.place_id = place_id
	def getPlace_id( self ) :
		return self.place_id

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	def setB1_name( self, b1_name ) :
		self.b1_name = b1_name
	def getB1_name( self ) :
		return self.b1_name

	def setC2_name( self, c2_name ) :
		self.c2_name = c2_name
	def getC2_name( self ) :
		return self.c2_name

	def setD3_name( self, d3_name ) :
		self.d3_name = d3_name
	def getD3_name( self ) :
		return self.d3_name

	def setE4_name( self, e4_name ) :
		self.e4_name = e4_name
	def getE4_name( self ) :
		return self.e4_name

	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class MediasDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.url as 'url', a.datemedia as 'datemedia', a.datemedia_format as 'datemedia_format', a.datemedia_accurate as 'datemedia_accurate', a.description as 'description', a.dimension as 'dimension', a.origin as 'origin', a.private as 'private', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.keyword as 'keyword', a.documenttype_id as 'documenttype_id', a.depot_id as 'depot_id', a.event_id as 'event_id', a.place_id as 'place_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name'	\
				from media a \
 				left outer join place e4 on e4.id =  a.place_id \
 				left outer join event d3 on d3.id =  a.event_id \
 				left outer join depot c2 on c2.id =  a.depot_id \
 				left outer join documenttype b1 on b1.id =  a.documenttype_id \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					mediaObj = Media( dbvalue['id'], dbvalue['name'], dbvalue['url'], dbvalue['datemedia'], dbvalue['datemedia_format'], dbvalue['datemedia_accurate'], dbvalue['description'], dbvalue['dimension'], dbvalue['origin'], dbvalue['private'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['keyword'], dbvalue['documenttype_id'], dbvalue['depot_id'], dbvalue['event_id'], dbvalue['place_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'] )
					resultlist.append( mediaObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.url as 'url', a.datemedia as 'datemedia', a.datemedia_format as 'datemedia_format', a.datemedia_accurate as 'datemedia_accurate', a.description as 'description', a.dimension as 'dimension', a.origin as 'origin', a.private as 'private', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.keyword as 'keyword', a.documenttype_id as 'documenttype_id', a.depot_id as 'depot_id', a.event_id as 'event_id', a.place_id as 'place_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name'	\
				from media a \
 				left outer join place e4 on e4.id =  a.place_id \
 				left outer join event d3 on d3.id =  a.event_id \
 				left outer join depot c2 on c2.id =  a.depot_id \
 				left outer join documenttype b1 on b1.id =  a.documenttype_id \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					mediaObj = Media( dbvalue['id'], dbvalue['name'], dbvalue['url'], dbvalue['datemedia'], dbvalue['datemedia_format'], dbvalue['datemedia_accurate'], dbvalue['description'], dbvalue['dimension'], dbvalue['origin'], dbvalue['private'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['keyword'], dbvalue['documenttype_id'], dbvalue['depot_id'], dbvalue['event_id'], dbvalue['place_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'] )
					resultlist.append( mediaObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.url as 'url', a.datemedia as 'datemedia', a.datemedia_format as 'datemedia_format', a.datemedia_accurate as 'datemedia_accurate', a.description as 'description', a.dimension as 'dimension', a.origin as 'origin', a.private as 'private', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.keyword as 'keyword', a.documenttype_id as 'documenttype_id', a.depot_id as 'depot_id', a.event_id as 'event_id', a.place_id as 'place_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name'	\
				from media a \
 				left outer join place e4 on e4.id =  a.place_id \
 				left outer join event d3 on d3.id =  a.event_id \
 				left outer join depot c2 on c2.id =  a.depot_id \
 				left outer join documenttype b1 on b1.id =  a.documenttype_id \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					mediaObj = Media( dbvalue['id'], dbvalue['name'], dbvalue['url'], dbvalue['datemedia'], dbvalue['datemedia_format'], dbvalue['datemedia_accurate'], dbvalue['description'], dbvalue['dimension'], dbvalue['origin'], dbvalue['private'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['keyword'], dbvalue['documenttype_id'], dbvalue['depot_id'], dbvalue['event_id'], dbvalue['place_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'] )
					resultlist.append( mediaObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.url as 'url', a.datemedia as 'datemedia', a.datemedia_format as 'datemedia_format', a.datemedia_accurate as 'datemedia_accurate', a.description as 'description', a.dimension as 'dimension', a.origin as 'origin', a.private as 'private', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.keyword as 'keyword', a.documenttype_id as 'documenttype_id', a.depot_id as 'depot_id', a.event_id as 'event_id', a.place_id as 'place_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name', d3.name as 'd3.name', e4.name as 'e4.name'	\
				from media a \
 				left outer join place e4 on e4.id =  a.place_id \
 				left outer join event d3 on d3.id =  a.event_id \
 				left outer join depot c2 on c2.id =  a.depot_id \
 				left outer join documenttype b1 on b1.id =  a.documenttype_id \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					mediaObj = Media( dbvalue['id'], dbvalue['name'], dbvalue['url'], dbvalue['datemedia'], dbvalue['datemedia_format'], dbvalue['datemedia_accurate'], dbvalue['description'], dbvalue['dimension'], dbvalue['origin'], dbvalue['private'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['keyword'], dbvalue['documenttype_id'], dbvalue['depot_id'], dbvalue['event_id'], dbvalue['place_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'], dbvalue['d3.name'], dbvalue['e4.name'] )
					resultlist.append( mediaObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, mediaObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE media set name = ?, url = ?, datemedia = ?, datemedia_format = ?, datemedia_accurate = ?, description = ?, dimension = ?, origin = ?, private = ?, notesearch = ?, sortorder = ?, keyword = ?, documenttype_id = ?, depot_id = ?, event_id = ?, place_id = ?, datecreated = ?  WHERE id = ?"

		try:
			if mediaObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ mediaObj.getSql(mediaObj.name),  mediaObj.getSql(mediaObj.url),  mediaObj.getSql(mediaObj.datemedia),  mediaObj.getSql(mediaObj.datemedia_format),  mediaObj.getSql(mediaObj.datemedia_accurate),  mediaObj.getSql(mediaObj.description),  mediaObj.getSql(mediaObj.dimension),  mediaObj.getSql(mediaObj.origin),  mediaObj.getSql(mediaObj.private),  mediaObj.getSql(mediaObj.notesearch),  mediaObj.getSql(mediaObj.sortorder),  mediaObj.getSql(mediaObj.keyword),  mediaObj.getSql(mediaObj.documenttype_id),  mediaObj.getSql(mediaObj.depot_id),  mediaObj.getSql(mediaObj.event_id),  mediaObj.getSql(mediaObj.place_id),  mediaObj.getSql(mediaObj.datecreated) , mediaObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = mediaObj.id
					return True
				else :
					result = self.insert ( mediaObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( mediaObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( mediaObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( mediaObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( mediaObj , self.lastError, sqlSt )

		return False

	def insert ( self, mediaObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO media ( name,  url,  datemedia,  datemedia_format,  datemedia_accurate,  description,  dimension,  origin,  private,  notesearch,  sortorder,  keyword,  documenttype_id,  depot_id,  event_id,  place_id,  datecreated ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  mediaObj.getSql(mediaObj.name),  mediaObj.getSql(mediaObj.url),  mediaObj.getSql(mediaObj.datemedia),  mediaObj.getSql(mediaObj.datemedia_format),  mediaObj.getSql(mediaObj.datemedia_accurate),  mediaObj.getSql(mediaObj.description),  mediaObj.getSql(mediaObj.dimension),  mediaObj.getSql(mediaObj.origin),  mediaObj.getSql(mediaObj.private),  mediaObj.getSql(mediaObj.notesearch),  mediaObj.getSql(mediaObj.sortorder),  mediaObj.getSql(mediaObj.keyword),  mediaObj.getSql(mediaObj.documenttype_id),  mediaObj.getSql(mediaObj.depot_id),  mediaObj.getSql(mediaObj.event_id),  mediaObj.getSql(mediaObj.place_id),  mediaObj.getSql(mediaObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( mediaObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( mediaObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM media WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from media' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  url = " + str( eventObj.url ))
		print("  datemedia = " + str( eventObj.datemedia ))
		print("  datemedia_format = " + str( eventObj.datemedia_format ))
		print("  datemedia_accurate = " + str( eventObj.datemedia_accurate ))
		print("  description = " + str( eventObj.description ))
		print("  dimension = " + str( eventObj.dimension ))
		print("  origin = " + str( eventObj.origin ))
		print("  private = " + str( eventObj.private ))
		print("  notesearch = " + str( eventObj.notesearch ))
		print("  sortorder = " + str( eventObj.sortorder ))
		print("  keyword = " + str( eventObj.keyword ))
		print("  documenttype_id = " + str( eventObj.documenttype_id ))
		print("  depot_id = " + str( eventObj.depot_id ))
		print("  event_id = " + str( eventObj.event_id ))
		print("  place_id = " + str( eventObj.place_id ))
		print("  datecreated = " + str( eventObj.datecreated ))

		print("  b1_name = " + str( eventObj.b1_name ))
		print("  c2_name = " + str( eventObj.c2_name ))
		print("  d3_name = " + str( eventObj.d3_name ))
		print("  e4_name = " + str( eventObj.e4_name ))


	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

