#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : media_person.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Media_person :

	log = None
	lastError = None

	id = None
	media_id = None
	person_id = None
	datecreated = None

	b1_name = None
	c2_name = None


	def __init__(self, id=None, media_id= None, person_id= None, datecreated= None,   b1_name= None, c2_name= None ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setMedia_id( media_id )
			self.setPerson_id( person_id )
			self.setDatecreated( datecreated )

			self.setB1_name( b1_name )
			self.setC2_name( c2_name )



		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setMedia_id( self, media_id ) :
		self.media_id = media_id
	def getMedia_id( self ) :
		return self.media_id

	def setPerson_id( self, person_id ) :
		self.person_id = person_id
	def getPerson_id( self ) :
		return self.person_id

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	def setB1_name( self, b1_name ) :
		self.b1_name = b1_name
	def getB1_name( self ) :
		return self.b1_name

	def setC2_name( self, c2_name ) :
		self.c2_name = c2_name
	def getC2_name( self ) :
		return self.c2_name

	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class Media_personsDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.media_id as 'media_id', a.person_id as 'person_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from media_person a \
 				left outer join person c2 on c2.id =  a.person_id \
 				left outer join media b1 on b1.id =  a.media_id \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					media_personObj = Media_person( dbvalue['id'], dbvalue['media_id'], dbvalue['person_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( media_personObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.media_id as 'media_id', a.person_id as 'person_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from media_person a \
 				left outer join person c2 on c2.id =  a.person_id \
 				left outer join media b1 on b1.id =  a.media_id \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					media_personObj = Media_person( dbvalue['id'], dbvalue['media_id'], dbvalue['person_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( media_personObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.media_id as 'media_id', a.person_id as 'person_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from media_person a \
 				left outer join person c2 on c2.id =  a.person_id \
 				left outer join media b1 on b1.id =  a.media_id \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					media_personObj = Media_person( dbvalue['id'], dbvalue['media_id'], dbvalue['person_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( media_personObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.media_id as 'media_id', a.person_id as 'person_id', a.datecreated as 'datecreated', \
				 b1.name as 'b1.name', c2.name as 'c2.name'	\
				from media_person a \
 				left outer join person c2 on c2.id =  a.person_id \
 				left outer join media b1 on b1.id =  a.media_id \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					media_personObj = Media_person( dbvalue['id'], dbvalue['media_id'], dbvalue['person_id'], dbvalue['datecreated'], 
										 dbvalue['b1.name'], dbvalue['c2.name'] )
					resultlist.append( media_personObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, media_personObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE media_person set media_id = ?, person_id = ?, datecreated = ?  WHERE id = ?"

		try:
			if media_personObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ media_personObj.getSql(media_personObj.media_id),  media_personObj.getSql(media_personObj.person_id),  media_personObj.getSql(media_personObj.datecreated) , media_personObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = media_personObj.id
					return True
				else :
					result = self.insert ( media_personObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( media_personObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( media_personObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( media_personObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( media_personObj , self.lastError, sqlSt )

		return False

	def insert ( self, media_personObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO media_person ( media_id,  person_id,  datecreated ) VALUES (?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  media_personObj.getSql(media_personObj.media_id),  media_personObj.getSql(media_personObj.person_id),  media_personObj.getSql(media_personObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( media_personObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( media_personObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM media_person WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from media_person' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  media_id = " + str( eventObj.media_id ))
		print("  person_id = " + str( eventObj.person_id ))
		print("  datecreated = " + str( eventObj.datecreated ))

		print("  b1_name = " + str( eventObj.b1_name ))
		print("  c2_name = " + str( eventObj.c2_name ))


	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

