#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : person.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Person :

	log = None
	lastError = None

	id = None
	name = None
	key = None
	description = None
	firstname = None
	lastname = None
	private = None
	icon = None
	sex = None
	notesearch = None
	firstnameprefix = None
	firtsnameothers = None
	lastnamesuffix = None
	surname = None
	datecreated = None



	def __init__(self, id=None, name= None, key= None, description= None, firstname= None, lastname= None, private= None, icon= None, sex= None, notesearch= None, firstnameprefix= None, firtsnameothers= None, lastnamesuffix= None, surname= None, datecreated= None   ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setKey( key )
			self.setDescription( description )
			self.setFirstname( firstname )
			self.setLastname( lastname )
			self.setPrivate( private )
			self.setIcon( icon )
			self.setSex( sex )
			self.setNotesearch( notesearch )
			self.setFirstnameprefix( firstnameprefix )
			self.setFirtsnameothers( firtsnameothers )
			self.setLastnamesuffix( lastnamesuffix )
			self.setSurname( surname )
			self.setDatecreated( datecreated )




		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setKey( self, key ) :
		self.key = key
	def getKey( self ) :
		return self.key

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setFirstname( self, firstname ) :
		self.firstname = firstname
	def getFirstname( self ) :
		return self.firstname

	def setLastname( self, lastname ) :
		self.lastname = lastname
	def getLastname( self ) :
		return self.lastname

	def setPrivate( self, private ) :
		self.private = private
	def getPrivate( self ) :
		return self.private

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon

	def setSex( self, sex ) :
		self.sex = sex
	def getSex( self ) :
		return self.sex

	def setNotesearch( self, notesearch ) :
		self.notesearch = notesearch
	def getNotesearch( self ) :
		return self.notesearch

	def setFirstnameprefix( self, firstnameprefix ) :
		self.firstnameprefix = firstnameprefix
	def getFirstnameprefix( self ) :
		return self.firstnameprefix

	def setFirtsnameothers( self, firtsnameothers ) :
		self.firtsnameothers = firtsnameothers
	def getFirtsnameothers( self ) :
		return self.firtsnameothers

	def setLastnamesuffix( self, lastnamesuffix ) :
		self.lastnamesuffix = lastnamesuffix
	def getLastnamesuffix( self ) :
		return self.lastnamesuffix

	def setSurname( self, surname ) :
		self.surname = surname
	def getSurname( self ) :
		return self.surname

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class PersonsDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.key as 'key', a.description as 'description', a.firstname as 'firstname', a.lastname as 'lastname', a.private as 'private', a.icon as 'icon', a.sex as 'sex', a.notesearch as 'notesearch', a.firstnameprefix as 'firstnameprefix', a.firtsnameothers as 'firtsnameothers', a.lastnamesuffix as 'lastnamesuffix', a.surname as 'surname', a.datecreated as 'datecreated' \
					\
				from person a \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					personObj = Person( dbvalue['id'], dbvalue['name'], dbvalue['key'], dbvalue['description'], dbvalue['firstname'], dbvalue['lastname'], dbvalue['private'], dbvalue['icon'], dbvalue['sex'], dbvalue['notesearch'], dbvalue['firstnameprefix'], dbvalue['firtsnameothers'], dbvalue['lastnamesuffix'], dbvalue['surname'], dbvalue['datecreated'] 
										 )
					resultlist.append( personObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.key as 'key', a.description as 'description', a.firstname as 'firstname', a.lastname as 'lastname', a.private as 'private', a.icon as 'icon', a.sex as 'sex', a.notesearch as 'notesearch', a.firstnameprefix as 'firstnameprefix', a.firtsnameothers as 'firtsnameothers', a.lastnamesuffix as 'lastnamesuffix', a.surname as 'surname', a.datecreated as 'datecreated' \
					\
				from person a \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					personObj = Person( dbvalue['id'], dbvalue['name'], dbvalue['key'], dbvalue['description'], dbvalue['firstname'], dbvalue['lastname'], dbvalue['private'], dbvalue['icon'], dbvalue['sex'], dbvalue['notesearch'], dbvalue['firstnameprefix'], dbvalue['firtsnameothers'], dbvalue['lastnamesuffix'], dbvalue['surname'], dbvalue['datecreated'] 
										 )
					resultlist.append( personObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.key as 'key', a.description as 'description', a.firstname as 'firstname', a.lastname as 'lastname', a.private as 'private', a.icon as 'icon', a.sex as 'sex', a.notesearch as 'notesearch', a.firstnameprefix as 'firstnameprefix', a.firtsnameothers as 'firtsnameothers', a.lastnamesuffix as 'lastnamesuffix', a.surname as 'surname', a.datecreated as 'datecreated' \
					\
				from person a \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					personObj = Person( dbvalue['id'], dbvalue['name'], dbvalue['key'], dbvalue['description'], dbvalue['firstname'], dbvalue['lastname'], dbvalue['private'], dbvalue['icon'], dbvalue['sex'], dbvalue['notesearch'], dbvalue['firstnameprefix'], dbvalue['firtsnameothers'], dbvalue['lastnamesuffix'], dbvalue['surname'], dbvalue['datecreated'] 
										 )
					resultlist.append( personObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.key as 'key', a.description as 'description', a.firstname as 'firstname', a.lastname as 'lastname', a.private as 'private', a.icon as 'icon', a.sex as 'sex', a.notesearch as 'notesearch', a.firstnameprefix as 'firstnameprefix', a.firtsnameothers as 'firtsnameothers', a.lastnamesuffix as 'lastnamesuffix', a.surname as 'surname', a.datecreated as 'datecreated' \
					\
				from person a \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					personObj = Person( dbvalue['id'], dbvalue['name'], dbvalue['key'], dbvalue['description'], dbvalue['firstname'], dbvalue['lastname'], dbvalue['private'], dbvalue['icon'], dbvalue['sex'], dbvalue['notesearch'], dbvalue['firstnameprefix'], dbvalue['firtsnameothers'], dbvalue['lastnamesuffix'], dbvalue['surname'], dbvalue['datecreated'] 
										 )
					resultlist.append( personObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, personObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE person set name = ?, key = ?, description = ?, firstname = ?, lastname = ?, private = ?, icon = ?, sex = ?, notesearch = ?, firstnameprefix = ?, firtsnameothers = ?, lastnamesuffix = ?, surname = ?, datecreated = ?  WHERE id = ?"

		try:
			if personObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ personObj.getSql(personObj.name),  personObj.getSql(personObj.key),  personObj.getSql(personObj.description),  personObj.getSql(personObj.firstname),  personObj.getSql(personObj.lastname),  personObj.getSql(personObj.private),  personObj.getSql(personObj.icon),  personObj.getSql(personObj.sex),  personObj.getSql(personObj.notesearch),  personObj.getSql(personObj.firstnameprefix),  personObj.getSql(personObj.firtsnameothers),  personObj.getSql(personObj.lastnamesuffix),  personObj.getSql(personObj.surname),  personObj.getSql(personObj.datecreated) , personObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = personObj.id
					return True
				else :
					result = self.insert ( personObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( personObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( personObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( personObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( personObj , self.lastError, sqlSt )

		return False

	def insert ( self, personObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO person ( name,  key,  description,  firstname,  lastname,  private,  icon,  sex,  notesearch,  firstnameprefix,  firtsnameothers,  lastnamesuffix,  surname,  datecreated ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  personObj.getSql(personObj.name),  personObj.getSql(personObj.key),  personObj.getSql(personObj.description),  personObj.getSql(personObj.firstname),  personObj.getSql(personObj.lastname),  personObj.getSql(personObj.private),  personObj.getSql(personObj.icon),  personObj.getSql(personObj.sex),  personObj.getSql(personObj.notesearch),  personObj.getSql(personObj.firstnameprefix),  personObj.getSql(personObj.firtsnameothers),  personObj.getSql(personObj.lastnamesuffix),  personObj.getSql(personObj.surname),  personObj.getSql(personObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( personObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( personObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM person WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from person' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  key = " + str( eventObj.key ))
		print("  description = " + str( eventObj.description ))
		print("  firstname = " + str( eventObj.firstname ))
		print("  lastname = " + str( eventObj.lastname ))
		print("  private = " + str( eventObj.private ))
		print("  icon = " + str( eventObj.icon ))
		print("  sex = " + str( eventObj.sex ))
		print("  notesearch = " + str( eventObj.notesearch ))
		print("  firstnameprefix = " + str( eventObj.firstnameprefix ))
		print("  firtsnameothers = " + str( eventObj.firtsnameothers ))
		print("  lastnamesuffix = " + str( eventObj.lastnamesuffix ))
		print("  surname = " + str( eventObj.surname ))
		print("  datecreated = " + str( eventObj.datecreated ))



	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

