#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : place.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Place :

	log = None
	lastError = None

	id = None
	name = None
	description = None
	private = None
	icon = None
	adress1 = None
	adress2 = None
	zipcode = None
	city = None
	cityinsee = None
	country = None
	url = None
	accurate = None
	gpslat = None
	gpslon = None
	zoom = None
	datecreated = None



	def __init__(self, id=None, name= None, description= None, private= None, icon= None, adress1= None, adress2= None, zipcode= None, city= None, cityinsee= None, country= None, url= None, accurate= None, gpslat= None, gpslon= None, zoom= None, datecreated= None   ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setDescription( description )
			self.setPrivate( private )
			self.setIcon( icon )
			self.setAdress1( adress1 )
			self.setAdress2( adress2 )
			self.setZipcode( zipcode )
			self.setCity( city )
			self.setCityinsee( cityinsee )
			self.setCountry( country )
			self.setUrl( url )
			self.setAccurate( accurate )
			self.setGpslat( gpslat )
			self.setGpslon( gpslon )
			self.setZoom( zoom )
			self.setDatecreated( datecreated )




		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setPrivate( self, private ) :
		self.private = private
	def getPrivate( self ) :
		return self.private

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon

	def setAdress1( self, adress1 ) :
		self.adress1 = adress1
	def getAdress1( self ) :
		return self.adress1

	def setAdress2( self, adress2 ) :
		self.adress2 = adress2
	def getAdress2( self ) :
		return self.adress2

	def setZipcode( self, zipcode ) :
		self.zipcode = zipcode
	def getZipcode( self ) :
		return self.zipcode

	def setCity( self, city ) :
		self.city = city
	def getCity( self ) :
		return self.city

	def setCityinsee( self, cityinsee ) :
		self.cityinsee = cityinsee
	def getCityinsee( self ) :
		return self.cityinsee

	def setCountry( self, country ) :
		self.country = country
	def getCountry( self ) :
		return self.country

	def setUrl( self, url ) :
		self.url = url
	def getUrl( self ) :
		return self.url

	def setAccurate( self, accurate ) :
		self.accurate = accurate
	def getAccurate( self ) :
		return self.accurate

	def setGpslat( self, gpslat ) :
		self.gpslat = gpslat
	def getGpslat( self ) :
		return self.gpslat

	def setGpslon( self, gpslon ) :
		self.gpslon = gpslon
	def getGpslon( self ) :
		return self.gpslon

	def setZoom( self, zoom ) :
		self.zoom = zoom
	def getZoom( self ) :
		return self.zoom

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class PlacesDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.adress1 as 'adress1', a.adress2 as 'adress2', a.zipcode as 'zipcode', a.city as 'city', a.cityinsee as 'cityinsee', a.country as 'country', a.url as 'url', a.accurate as 'accurate', a.gpslat as 'gpslat', a.gpslon as 'gpslon', a.zoom as 'zoom', a.datecreated as 'datecreated' \
					\
				from place a \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					placeObj = Place( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['adress1'], dbvalue['adress2'], dbvalue['zipcode'], dbvalue['city'], dbvalue['cityinsee'], dbvalue['country'], dbvalue['url'], dbvalue['accurate'], dbvalue['gpslat'], dbvalue['gpslon'], dbvalue['zoom'], dbvalue['datecreated'] 
										 )
					resultlist.append( placeObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.adress1 as 'adress1', a.adress2 as 'adress2', a.zipcode as 'zipcode', a.city as 'city', a.cityinsee as 'cityinsee', a.country as 'country', a.url as 'url', a.accurate as 'accurate', a.gpslat as 'gpslat', a.gpslon as 'gpslon', a.zoom as 'zoom', a.datecreated as 'datecreated' \
					\
				from place a \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					placeObj = Place( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['adress1'], dbvalue['adress2'], dbvalue['zipcode'], dbvalue['city'], dbvalue['cityinsee'], dbvalue['country'], dbvalue['url'], dbvalue['accurate'], dbvalue['gpslat'], dbvalue['gpslon'], dbvalue['zoom'], dbvalue['datecreated'] 
										 )
					resultlist.append( placeObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.adress1 as 'adress1', a.adress2 as 'adress2', a.zipcode as 'zipcode', a.city as 'city', a.cityinsee as 'cityinsee', a.country as 'country', a.url as 'url', a.accurate as 'accurate', a.gpslat as 'gpslat', a.gpslon as 'gpslon', a.zoom as 'zoom', a.datecreated as 'datecreated' \
					\
				from place a \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					placeObj = Place( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['adress1'], dbvalue['adress2'], dbvalue['zipcode'], dbvalue['city'], dbvalue['cityinsee'], dbvalue['country'], dbvalue['url'], dbvalue['accurate'], dbvalue['gpslat'], dbvalue['gpslon'], dbvalue['zoom'], dbvalue['datecreated'] 
										 )
					resultlist.append( placeObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.adress1 as 'adress1', a.adress2 as 'adress2', a.zipcode as 'zipcode', a.city as 'city', a.cityinsee as 'cityinsee', a.country as 'country', a.url as 'url', a.accurate as 'accurate', a.gpslat as 'gpslat', a.gpslon as 'gpslon', a.zoom as 'zoom', a.datecreated as 'datecreated' \
					\
				from place a \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					placeObj = Place( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['adress1'], dbvalue['adress2'], dbvalue['zipcode'], dbvalue['city'], dbvalue['cityinsee'], dbvalue['country'], dbvalue['url'], dbvalue['accurate'], dbvalue['gpslat'], dbvalue['gpslon'], dbvalue['zoom'], dbvalue['datecreated'] 
										 )
					resultlist.append( placeObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, placeObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE place set name = ?, description = ?, private = ?, icon = ?, adress1 = ?, adress2 = ?, zipcode = ?, city = ?, cityinsee = ?, country = ?, url = ?, accurate = ?, gpslat = ?, gpslon = ?, zoom = ?, datecreated = ?  WHERE id = ?"

		try:
			if placeObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ placeObj.getSql(placeObj.name),  placeObj.getSql(placeObj.description),  placeObj.getSql(placeObj.private),  placeObj.getSql(placeObj.icon),  placeObj.getSql(placeObj.adress1),  placeObj.getSql(placeObj.adress2),  placeObj.getSql(placeObj.zipcode),  placeObj.getSql(placeObj.city),  placeObj.getSql(placeObj.cityinsee),  placeObj.getSql(placeObj.country),  placeObj.getSql(placeObj.url),  placeObj.getSql(placeObj.accurate),  placeObj.getSql(placeObj.gpslat),  placeObj.getSql(placeObj.gpslon),  placeObj.getSql(placeObj.zoom),  placeObj.getSql(placeObj.datecreated) , placeObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = placeObj.id
					return True
				else :
					result = self.insert ( placeObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( placeObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( placeObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( placeObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( placeObj , self.lastError, sqlSt )

		return False

	def insert ( self, placeObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO place ( name,  description,  private,  icon,  adress1,  adress2,  zipcode,  city,  cityinsee,  country,  url,  accurate,  gpslat,  gpslon,  zoom,  datecreated ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  placeObj.getSql(placeObj.name),  placeObj.getSql(placeObj.description),  placeObj.getSql(placeObj.private),  placeObj.getSql(placeObj.icon),  placeObj.getSql(placeObj.adress1),  placeObj.getSql(placeObj.adress2),  placeObj.getSql(placeObj.zipcode),  placeObj.getSql(placeObj.city),  placeObj.getSql(placeObj.cityinsee),  placeObj.getSql(placeObj.country),  placeObj.getSql(placeObj.url),  placeObj.getSql(placeObj.accurate),  placeObj.getSql(placeObj.gpslat),  placeObj.getSql(placeObj.gpslon),  placeObj.getSql(placeObj.zoom),  placeObj.getSql(placeObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( placeObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( placeObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM place WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from place' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  description = " + str( eventObj.description ))
		print("  private = " + str( eventObj.private ))
		print("  icon = " + str( eventObj.icon ))
		print("  adress1 = " + str( eventObj.adress1 ))
		print("  adress2 = " + str( eventObj.adress2 ))
		print("  zipcode = " + str( eventObj.zipcode ))
		print("  city = " + str( eventObj.city ))
		print("  cityinsee = " + str( eventObj.cityinsee ))
		print("  country = " + str( eventObj.country ))
		print("  url = " + str( eventObj.url ))
		print("  accurate = " + str( eventObj.accurate ))
		print("  gpslat = " + str( eventObj.gpslat ))
		print("  gpslon = " + str( eventObj.gpslon ))
		print("  zoom = " + str( eventObj.zoom ))
		print("  datecreated = " + str( eventObj.datecreated ))



	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

