#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik

		*** Source autogénéré *** 

		Classe de base pour la table : source.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache
from lib.sqlitedb import Sqlitedb

import lib.log as AppLog
from lib.log import LOG_ARGVAL,LOG_INFO,LOG_INFOSETTING,LOG_WARNING,LOG_ERROR,LOG_DEBUG,LOG_FATAL
	
from lib.util import Util
import lib.setting as AppSetting

class Source :

	log = None
	lastError = None

	id = None
	name = None
	description = None
	private = None
	icon = None
	quality = None
	localurl = None
	sourceurl = None
	sourcetext = None
	page = None
	citation = None
	textdraduction = None
	notesearch = None
	sortorder = None
	datecreated = None



	def __init__(self, id=None, name= None, description= None, private= None, icon= None, quality= None, localurl= None, sourceurl= None, sourcetext= None, page= None, citation= None, textdraduction= None, notesearch= None, sortorder= None, datecreated= None   ):
		
		self.lastError = None
		try:

			self.setId( id )
			self.setName( name )
			self.setDescription( description )
			self.setPrivate( private )
			self.setIcon( icon )
			self.setQuality( quality )
			self.setLocalurl( localurl )
			self.setSourceurl( sourceurl )
			self.setSourcetext( sourcetext )
			self.setPage( page )
			self.setCitation( citation )
			self.setTextdraduction( textdraduction )
			self.setNotesearch( notesearch )
			self.setSortorder( sortorder )
			self.setDatecreated( datecreated )




		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

	def getSql( self, sqlValue  ) :
		if sqlValue == '' :
			return None
		return sqlValue

	def setId( self, id ) :
		self.id = id
	def getId( self ) :
		return self.id

	def setName( self, name ) :
		self.name = name
	def getName( self ) :
		return self.name

	def setDescription( self, description ) :
		self.description = description
	def getDescription( self ) :
		return self.description

	def setPrivate( self, private ) :
		self.private = private
	def getPrivate( self ) :
		return self.private

	def setIcon( self, icon ) :
		self.icon = icon
	def getIcon( self ) :
		return self.icon

	def setQuality( self, quality ) :
		self.quality = quality
	def getQuality( self ) :
		return self.quality

	def setLocalurl( self, localurl ) :
		self.localurl = localurl
	def getLocalurl( self ) :
		return self.localurl

	def setSourceurl( self, sourceurl ) :
		self.sourceurl = sourceurl
	def getSourceurl( self ) :
		return self.sourceurl

	def setSourcetext( self, sourcetext ) :
		self.sourcetext = sourcetext
	def getSourcetext( self ) :
		return self.sourcetext

	def setPage( self, page ) :
		self.page = page
	def getPage( self ) :
		return self.page

	def setCitation( self, citation ) :
		self.citation = citation
	def getCitation( self ) :
		return self.citation

	def setTextdraduction( self, textdraduction ) :
		self.textdraduction = textdraduction
	def getTextdraduction( self ) :
		return self.textdraduction

	def setNotesearch( self, notesearch ) :
		self.notesearch = notesearch
	def getNotesearch( self ) :
		return self.notesearch

	def setSortorder( self, sortorder ) :
		self.sortorder = sortorder
	def getSortorder( self ) :
		return self.sortorder

	def setDatecreated( self, datecreated ) :
		self.datecreated = datecreated
	def getDatecreated( self ) :
		return self.datecreated


	

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

'''

'''
class SourcesDb ( Sqlitedb ):

	log = None

	lastError = None
	db = None
	countStats = None

	def __init__(self, db ):

		self.lastError = None
		
		try:
			self.db = db
			pass

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()


	def selectAll( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.quality as 'quality', a.localurl as 'localurl', a.sourceurl as 'sourceurl', a.sourcetext as 'sourcetext', a.page as 'page', a.citation as 'citation', a.textdraduction as 'textdraduction', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.datecreated as 'datecreated' \
					\
				from source a \
					"				
			resultrows = self.db.query( sqlSt )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					sourceObj = Source( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['quality'], dbvalue['localurl'], dbvalue['sourceurl'], dbvalue['sourcetext'], dbvalue['page'], dbvalue['citation'], dbvalue['textdraduction'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['datecreated'] 
										 )
					resultlist.append( sourceObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectById ( self , where_clause, fields_values ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.quality as 'quality', a.localurl as 'localurl', a.sourceurl as 'sourceurl', a.sourcetext as 'sourcetext', a.page as 'page', a.citation as 'citation', a.textdraduction as 'textdraduction', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.datecreated as 'datecreated' \
					\
				from source a \
					"

			sqlSt = sqlSt + " {where}".format(where = where_clause)
			
			resultrows = self.db.query( sqlSt, fields_values )
			self.selectCount = len(resultrows)
			
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					sourceObj = Source( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['quality'], dbvalue['localurl'], dbvalue['sourceurl'], dbvalue['sourcetext'], dbvalue['page'], dbvalue['citation'], dbvalue['textdraduction'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['datecreated'] 
										 )
					resultlist.append( sourceObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False
		
		
	def select ( self , id ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			
			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.quality as 'quality', a.localurl as 'localurl', a.sourceurl as 'sourceurl', a.sourcetext as 'sourcetext', a.page as 'page', a.citation as 'citation', a.textdraduction as 'textdraduction', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.datecreated as 'datecreated' \
					\
				from source a \
					WHERE a.id = ? "				

			resultrows = self.db.query( sqlSt, [id] )
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					sourceObj = Source( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['quality'], dbvalue['localurl'], dbvalue['sourceurl'], dbvalue['sourcetext'], dbvalue['page'], dbvalue['citation'], dbvalue['textdraduction'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['datecreated'] 
										 )
					resultlist.append( sourceObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def selectByPos ( self , recPos, subIdList, orderByFields, orderBy  ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:

			sqlSt = "SELECT \
				a.id as 'id', \
				a.name as 'name', a.description as 'description', a.private as 'private', a.icon as 'icon', a.quality as 'quality', a.localurl as 'localurl', a.sourceurl as 'sourceurl', a.sourcetext as 'sourcetext', a.page as 'page', a.citation as 'citation', a.textdraduction as 'textdraduction', a.notesearch as 'notesearch', a.sortorder as 'sortorder', a.datecreated as 'datecreated' \
					\
				from source a \
					"				
			sqlSt = sqlSt + 'where a.id in ('\
				+ ",".join(map(str, subIdList))  + \
				') order by '+orderByFields+' ' +orderBy+' limit ?,1'
				
			resultrows = self.db.query(sqlSt, [recPos])	
			
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:

					sourceObj = Source( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['quality'], dbvalue['localurl'], dbvalue['sourceurl'], dbvalue['sourcetext'], dbvalue['page'], dbvalue['citation'], dbvalue['textdraduction'], dbvalue['notesearch'], dbvalue['sortorder'], dbvalue['datecreated'] 
										 )
					resultlist.append( sourceObj )

				return resultlist[0]
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def update( self, sourceObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE source set name = ?, description = ?, private = ?, icon = ?, quality = ?, localurl = ?, sourceurl = ?, sourcetext = ?, page = ?, citation = ?, textdraduction = ?, notesearch = ?, sortorder = ?, datecreated = ?  WHERE id = ?"

		try:
			if sourceObj.id != -1 :
				result = self.db.execute(sqlSt,
					[ sourceObj.getSql(sourceObj.name),  sourceObj.getSql(sourceObj.description),  sourceObj.getSql(sourceObj.private),  sourceObj.getSql(sourceObj.icon),  sourceObj.getSql(sourceObj.quality),  sourceObj.getSql(sourceObj.localurl),  sourceObj.getSql(sourceObj.sourceurl),  sourceObj.getSql(sourceObj.sourcetext),  sourceObj.getSql(sourceObj.page),  sourceObj.getSql(sourceObj.citation),  sourceObj.getSql(sourceObj.textdraduction),  sourceObj.getSql(sourceObj.notesearch),  sourceObj.getSql(sourceObj.sortorder),  sourceObj.getSql(sourceObj.datecreated) , sourceObj.id ])

				if self.db.cursor.rowcount >= 1 :
					self.db.commit()
					self.lastInsertId = sourceObj.id
					return True
				else :
					result = self.insert ( sourceObj )
					if result is True :
						self.db.commit()
						return True
					else :
						self.lastError = str(self.db.lastError)
						self.dumpObj( sourceObj , self.lastError, sqlSt )
						return False
			else :
				result = self.insert ( sourceObj )
				if result is True :
					self.db.commit()
					return True
				else :
					self.lastError = str(self.db.lastError)
					self.dumpObj( sourceObj , self.lastError, sqlSt )
					return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( sourceObj , self.lastError, sqlSt )

		return False

	def insert ( self, sourceObj ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "INSERT INTO source ( name,  description,  private,  icon,  quality,  localurl,  sourceurl,  sourcetext,  page,  citation,  textdraduction,  notesearch,  sortorder,  datecreated ) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )"

		try:
			result = self.db.execute(sqlSt,
				[  sourceObj.getSql(sourceObj.name),  sourceObj.getSql(sourceObj.description),  sourceObj.getSql(sourceObj.private),  sourceObj.getSql(sourceObj.icon),  sourceObj.getSql(sourceObj.quality),  sourceObj.getSql(sourceObj.localurl),  sourceObj.getSql(sourceObj.sourceurl),  sourceObj.getSql(sourceObj.sourcetext),  sourceObj.getSql(sourceObj.page),  sourceObj.getSql(sourceObj.citation),  sourceObj.getSql(sourceObj.textdraduction),  sourceObj.getSql(sourceObj.notesearch),  sourceObj.getSql(sourceObj.sortorder),  sourceObj.getSql(sourceObj.datecreated)  ] )

			if result is True :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				self.dumpObj( sourceObj , self.lastError, sqlSt )
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			self.dumpObj( sourceObj , self.lastError, sqlSt )

		return False

	def delete ( self, id ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "DELETE FROM source WHERE id = ?"

		try:
			result = self.db.execute(sqlSt,
				[id] )

			if self.db.cursor.rowcount >= 1 :
				self.db.commit()
				self.lastInsertId = self.db.lastInsertId
				return True
			else :
				self.lastError = str(self.db.lastError)
				return False

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
			return False

		return False

		
	def getCount ( self ) :
		
		self.lastError = None
		self.lastInsertId = None
		self.countStats = {}
		self.countStats['minid'] = None
		self.countStats['maxid'] = None
		self.countStats['count'] = None

		try:

			resultrows = self.db.query( 'select min(id) as minid, max(id) as maxid, count(*) as count  from source' )
			for dbvalue in resultrows:
				self.countStats['minid'] = dbvalue['minid']
				self.countStats['maxid'] = dbvalue['maxid']
				self.countStats['count'] = dbvalue['count']

			return self.countStats

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def dumpObj( self, eventObj , lastError, message ) :
		print("----------------------------------")
		print(message)
		print("LastError : " + str(lastError))

		print("Id = " + str(eventObj.id))
		print("  name = " + str( eventObj.name ))
		print("  description = " + str( eventObj.description ))
		print("  private = " + str( eventObj.private ))
		print("  icon = " + str( eventObj.icon ))
		print("  quality = " + str( eventObj.quality ))
		print("  localurl = " + str( eventObj.localurl ))
		print("  sourceurl = " + str( eventObj.sourceurl ))
		print("  sourcetext = " + str( eventObj.sourcetext ))
		print("  page = " + str( eventObj.page ))
		print("  citation = " + str( eventObj.citation ))
		print("  textdraduction = " + str( eventObj.textdraduction ))
		print("  notesearch = " + str( eventObj.notesearch ))
		print("  sortorder = " + str( eventObj.sortorder ))
		print("  datecreated = " + str( eventObj.datecreated ))



	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
		AppLog.log( LOG_ERROR , 'EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))

