#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''

		Généalogik

		Custom Class for table : event_source.

		07/05/2021 22:10

		lvardon@laposte.net - 2021

		Licence libre


'''
import sys
import linecache


from libdb.event_source import Event_sourcesDb, Event_source

class Event_sources ( Event_sourcesDb ):

	db = None
	lastError = None

	def __init__(self, db ):
		super().__init__( db )
		self.db = db		

	# Custom selects
	def selectCustom( self, rowPropertyId  ) :
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			resultrows = self.db.query( 'SELECT * FROM event_source where person_1_id = ?' , [ rowPropertyId ])
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:
					
					event_sourceObj = Event_source( dbvalue['id'], dbvalue['event_id'], dbvalue['source_id'], dbvalue['document_id'], dbvalue['datecreated']  )
					resultlist.append( event_sourceObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
