#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''

		Généalogik

		Custom Class for table : media_person.

		04/21/2022 16:09

		lvardon@laposte.net - 2021

		Licence libre


'''

import sys
import linecache

from libdb.media_person import Media_personsDb, Media_person

class Media_persons ( Media_personsDb ):

	db = None
	lastError = None

	def __init__(self, db ):
		super().__init__( db )
		self.db = db		

	# Custom selects
	def selectCustom( self, rowPropertyId  ) :
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			resultrows = self.db.query( 'SELECT * FROM media_person where person_1_id = ?' , [ rowPropertyId ])
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:
					
					media_personObj = Media_person( dbvalue['id'], dbvalue['media'], dbvalue['person'], dbvalue['datecreated']  )
					resultlist.append( media_personObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
