#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''

		Généalogik

		Custom Class for table : source.

		07/05/2021 22:10

		lvardon@laposte.net - 2021

		Licence libre


'''
import sys
import linecache

from libdb.source import SourcesDb, Source

class Sources ( SourcesDb ):

	db = None
	lastError = None

	def __init__(self, db ):
		super().__init__( db )
		self.db = db		

	def updateCustomImageFileName( self, oldFileName, newfileName ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE source set localurl = replace( localurl, ?, ?) where localurl like ?"

		try:
			result = self.db.execute(sqlSt,
				[ oldFileName, newfileName, "%"+oldFileName+"%" ])

			return True

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

		return False

	def updateCustomIconFileName( self, oldFileName, newfileName ) :
		self.lastError = None
		self.lastInsertId = None
		sqlSt = "UPDATE source set icon = replace( icon, ?, ?) where icon like ?"

		try:
			result = self.db.execute(sqlSt,
				[ oldFileName, newfileName, "%"+oldFileName+"%" ])

			return True

		except Exception as e:
			self.lastError = str(e)
			self.PrintException()

		return False
		
	# Custom selects
	def selectCustom( self, rowPropertyId  ) :
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			resultrows = self.db.query( 'SELECT * FROM source where person_1_id = ?' , [ rowPropertyId ])
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:
					
					sourceObj = Source( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['category'], dbvalue['icon'], dbvalue['sourcetext'], dbvalue['sourceurl'], dbvalue['quality'], dbvalue['page'], dbvalue['citation'], dbvalue['textdraduction'], dbvalue['notesearch'], dbvalue['datecreated']  )
					resultlist.append( sourceObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False


	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
