#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik
		
		*** Source autogénéré *** 

		Classe spécifique pour la table : event.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache

from libdb.event import EventsDb, Event

class Events ( EventsDb ):

	db = None
	lastError = None

	def __init__(self, db ):
		super().__init__( db )
		self.db = db		

	# Custom selects
	def selectCustom( self, rowPropertyId  ) :
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			resultrows = self.db.query( 'SELECT * FROM event where person_1_id = ?' , [ rowPropertyId ])
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:
					
					eventObj = Event( dbvalue['id'], dbvalue['name'], dbvalue['description'], dbvalue['private'], dbvalue['icon'], dbvalue['date_begin'], dbvalue['date_begin_format'], dbvalue['date_begin_accurate'], dbvalue['notesearch'], dbvalue['person_1_id'], dbvalue['person_2_id'], dbvalue['person_3_id'], dbvalue['eventtype_id'], dbvalue['place_id'], dbvalue['datecreated'], dbvalue['sortorder']  )
					resultlist.append( eventObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
