#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
		Généalogik
		
		*** Source autogénéré *** 

		Classe spécifique pour la table : person.

		05/24/2023 14:31

		lvardon@laposte.net - 2021

		Licence libre

'''

import sys
import linecache

from libdb.person import PersonsDb, Person

class Persons ( PersonsDb ):

	db = None
	lastError = None

	def __init__(self, db ):
		super().__init__( db )
		self.db = db		

	# Custom selects
	def selectCustom( self, rowPropertyId  ) :
		self.lastError = None
		self.lastInsertId = None
		self.selectCount = None
		resultlist = []
		try:
			resultrows = self.db.query( 'SELECT * FROM person where person_1_id = ?' , [ rowPropertyId ])
			self.selectCount = len(resultrows)
			if	self.selectCount > 0 :
				for dbvalue in resultrows:
					
					personObj = Person( dbvalue['id'], dbvalue['name'], dbvalue['key'], dbvalue['description'], dbvalue['firstname'], dbvalue['lastname'], dbvalue['private'], dbvalue['icon'], dbvalue['sex'], dbvalue['notesearch'], dbvalue['firstnameprefix'], dbvalue['firtsnameothers'], dbvalue['lastnamesuffix'], dbvalue['surname'], dbvalue['datecreated']  )
					resultlist.append( personObj )

				return resultlist
			else :
				return False
		except Exception as e:
			self.lastError = str(e)
			self.PrintException()
		return False

	def PrintException(self):
		exc_type, exc_obj, tb = sys.exc_info()
		f = tb.tb_frame
		lineno = tb.tb_lineno
		filename = f.f_code.co_filename
		linecache.checkcache(filename)
		line = linecache.getline(filename, lineno, f.f_globals)
		print ('EXCEPTION IN ({}, LINE {} "{}"): {}'.format(filename, lineno, line.strip(), exc_obj))
